/*
 * This file is part of leds.
 * 
 * leds is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * leds is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with leds; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

module leds.Docker;

private import std.gc;

private import dui.All;

private import leds.FileView;
//private import leds.Project; stupid thing can't deal with this!!!!!!!!!!!!!
// walter just keeps ignoring/dismissing this problem !!!!!!!!!!!!!!!!!!!!!!!
// it's the forward reference again !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

/**
 * Define what is a Dockable
 */
public:
interface Dockable
{
	void setDocker(Docker docker);
	Widget getWidget();
	char[] getTabName();
	Menu getTabMenu();
	FileView getFileView();
	bit allowCloseButton();
	//Project getProject();
	bit allowClose();
	bit clear();
}

/**
 * A place to dock widget.
 * for now it's implemented through a notebook
 */
public:
class Docker : Dockable
{
	protected:
	char[] name;
	bit horizontal;
	Container parent;
	Menu tabMenu;
	Docker docker;

	/**
	 * This is just to keep a reference to the element so D gc don't deletes them.
	 * not sure if that was the problem on the first place
	 */
	
	Dockable[] dockables;
	
	Notebook notebook;
	
	public:
	this(char[] name)
	{
		this(name,false);
	}
	
	this(char[] name, bit horizontal)
	{
		this.horizontal = horizontal;
		this.name = name.dup;
		notebook = new Notebook;
	}

	Widget getWidget()
	{
		return notebook;
	}
	
	char[] getTabName()
	{
		return name;
	}
	
	Menu getTabMenu()
	{
		if ( tabMenu === null )
		{
			tabMenu = new Menu();
			MenuItem item;
			
			//tabMenu.append(new MenuItem(this,"_Close","tabMenu.close"));
			//tabMenu.append(new MenuItem(this,"_Float","tabMenu.float"));
			tabMenu.append(new MenuItem("test"));
		}
		//return tabMenu;
		return null;
	}

	void setDocker(Docker docker)
	{
		this.docker = docker;
	}

	/**
	 * Gets this dockable file view
	 * @return null because with don't have a file view
	 */
	FileView getFileView()
	{
		return null;
	}
	
	bit allowCloseButton()
	{
		return false;
	}
	
	bit allowClose()
	{
		return true;
	}
	
	bit clear()
	{
		return false;
	}

	/**
	 * Add a new Dockable 
	 */
	void dock(Dockable dockable)
	{
		.fullCollect();

		Toolbar toolbar = new Toolbar();
		//toolbar.setIconSize(IconSize.MENU);
		toolbar.setIconSize(IconSize.SMALL_TOOLBAR);
		toolbar.setStyle(ToolbarStyle.ICONS);

		dockable.setDocker(this);
		Menu menu = dockable.getTabMenu();
		if ( menu !== null )
		{
			MenuItem item = new MenuItem(dockable.getTabName());
			item.setSubmenu(menu);
			MenuBar mb = new MenuBar();
			mb.append(item);
			mb.setBorderWidth(0);
			toolbar.appendWidget(mb,"","");
		}

		if ( menu !==null && dockable.allowCloseButton() )
		{
			Button button = (Button)toolbar.insertStock(Stock.CLOSE,"","",-1);
			notebook.appendPage(dockable.getWidget(), toolbar);
			notebook.setTabLabel(dockable.getWidget(), toolbar);
		}
		else
		{
			notebook.appendPage(dockable.getWidget(), dockable.getTabName());
		}
		notebook.setCurrentPage(notebook.getNPages()-1);
		dockables ~= dockable;
	}


	bit undockCurrent()
	{
		bit undocked = false;
		int index = notebook.getCurrentPage();
		Dockable d = dockables[index];
		if ( d.allowClose() )
		{
			undocked = true;
			notebook.removePage(index);
			// lets do as Walter wants... :p
			for ( int i = index ; i<(dockables.length-1) ;i++)
			{
				dockables[i] = dockables[i+1];
			}
			dockables.length = dockables.length-1;
		}
		return undocked;
	}

	void setScrollable(bit scrollable)
	{
		notebook.setScrollable(scrollable);
	}

	void setTabPos(PositionType posType)
	{
		notebook.setTabPos(posType);
	}

	FileView getFileView(int index)
	{
		return dockables[index].getFileView();
	}

	FileView getCurrentFileView()
	{	
		return getFileView(notebook.getCurrentPage());
	}

	Dockable getCurrentDockable()
	{	
		return dockables[notebook.getCurrentPage()];
	}

	int getNDocks()
	{
		return notebook.getNPages();
	}
	
	void setDockedLabelText(Dockable dockable, char[] labelText)
	{
		notebook.setTabLabelText(dockable.getWidget(), labelText);
	}
		
	void toggleVisible()
	{
//		if ( parent === null )
//		{
//			parent = (Container)getParent();
//			ref();
//			parent.remove(this);
//		}
//		else
//		{
//			parent.add(this);
//			unref();
//			parent = null;
//		}
	}
}
