/*
 * This file is part of leds.
 * 
 * leds is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * leds is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with leds; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

module leds.ExecConsole;

private import dui.All;

private import leds.Workspace;
private import leds.SystemConsole;
private import leds.Docker;
private import leds.POpen;


/**
 * SystemConsole
 */
public:
class ExecConsole : SystemConsole
{
	
	char[] tabName;
	/**
	 * Creates a new System console for a workspace
	 * @param workspace
	 */
	this(Workspace workspace, char[] label)
	{
		super(workspace);
		tabName = label.dup;
	}

	Widget getWidget()
	{
		return this;
	}
	
	char[] getTabName()
	{
		return tabName;
	}

	Menu getTabMenu()
	{
		if ( tabMenu === null )
		{
			tabMenu = new Menu();
			MenuItem item;
			
			tabMenu.append(new MenuItem(this,"_Close","tabMenu.close"));
			tabMenu.append(new MenuItem(this,"_Float","tabMenu.float"));
		}
		return tabMenu;
		//return null;
	}

	/**
	 * detrimines if a close button shoud be visible
	 */
	bit allowCloseButton()
	{
		return false;
	}

	bit allowClose()
	{
		return !executing;
	}
	
	void activateItemCallback(MenuItem menuItem, char [] action)
	{
		printf("Workspace.MenuListener.ctivateItemCallback %.*s\n",action);
	}

	/**
	 * Menu listener callback
	 */
	void activateCallback(MenuItem menuItem, char [] action)
	{
		switch(action)
		{
			case "tabMenu.close":
				if ( docker !== null )
				{
					docker.undockCurrent();
				}
				break;

			default:
				super.activateCallback(menuItem, action);
				break;
		}
	}

};
